#include "xbasic_types.h"
#include "xio.h"
#include "xparameters.h"
#include "xuartlite_l.h"
#include "xintc_l.h"
#include "xuartlite_l.h"
#include "hello_video.h"


char line[BUFFER_SIZE];
char *read = line, *write = line;
unsigned long intcounter;
unsigned long uartcounter;

extern volatile int size,lysize;
extern volatile unsigned char sambuf[16];
extern volatile unsigned char readybuf[16];
int mode;


void audio_handler( void *callback ) {

  Xuint32 IsrStatus;
  Xuint8 incoming_character;
  Xuint32 channel, sample;
  Xuint8 s;
  int i;
  
  for(i=0;i<64;i++){
    if ( !(i&0x03) ){
      s = readybuf[(i>>2)&0x0FF];
      channel = ( 0x000000FF & s ) << 7;
	sample = ( channel << 16 ) | channel;
	XIo_Out32( 0xFEFE0000 + i*4 , sample );
	continue;
    }
    XIo_Out32( 0xFEFE0000 + i*4, sample );
  }
  intcounter++;
}

/*
 * Interrupt service routine for the UART
 */
void uart_handler(void *callback){

  Xuint32 IsrStatus;
  Xuint8 incoming_character;
  int j;

  static i=0;
  IsrStatus = XIo_In32(XPAR_MYUART_BASEADDR + XUL_STATUS_REG_OFFSET);
  if ((IsrStatus & (XUL_SR_RX_FIFO_FULL | XUL_SR_RX_FIFO_VALID_DATA)) != 0) {
    incoming_character = (Xuint8) XIo_In32( XPAR_MYUART_BASEADDR + XUL_RX_FIFO_OFFSET );
    if (uartcounter>= (size+lysize*5+8))
	for(j=0;j<16;j++)
	  readybuf[j]=0;
      
    switch (mode){
    case 0:       // buffer;
      *write++ = incoming_character;
      if( write > &line[BUFFER_SIZE - 1] ) 
	write = line;
      break;
    case 1:       //stream;
      sambuf[i]=incoming_character;
      i++;
      if (i==16){
	for(j=0;j<16;j++)
	  readybuf[j]=sambuf[j];
	i=0;
	uartcounter++;      
      }
      break;
    
    }
  }
}
